/*
 * init_sint.c - sine/cosine luts init
 *
 * Copyright (c) 2010 ariel/KotCzarny
 *
 * This file is released under the GPLv2
 *
 */

#ifndef INC_init_sint
#define INC_init_sint

#ifndef USE_init_sint
void init_sint() {}
#else

#include <math.h>

int sint_inited=0;
static float sin_tab[36000];

//////#############
float sint(float a) {
 int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
}

//////#############
float cost(float a) { return sint(a+3.14159265/2.0); }

/////###########
void init_sint() {
 if(sint_inited) return;
 sint_inited=1; int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925);
}

#endif
#endif
