// [o] braided trippy floor - fast sint version

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[360*100];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2); }

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 unsigned int *isrc=(unsigned int *)src;
 int o, x, y, ww2=ww/2, wh2=wh/2;
 float *map=(float *)buf3;
 float fx=0.0,fy=0.0,fr;

 float x1,y1;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform cache..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   fx=3.1416*(x-ww2)/ww;
   fy=3.1416*(y-wh2)/wh;
   fr=sqrt(fx*fx+fy*fy)*10.0*6.0;

   //if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=fr;
  }
 }
 for(x=0;x<36000;x++) sin_tab[x]=sin(2.0*3.14159265*x/36000);
 printf("..done\n");
}

union color c1,c2,c3,c4;
int o0,i,x0,y0; float px,py,Px,Py,pp,pP,Pp,PP;
unsigned char r,g,b;
memset(dst,0,ww*4); memset(dst+ww*(wh-1)*4,0,ww*4);
for(i=0;i<wh;i++){ memset(dst+(i*ww*4),0,4); memset(dst+(i*ww*4+(ww-1)*4),0,4); }

for(y=1; y<wh-1; y++) { for(x=1; x<ww-1; x++) {

   fx=3.1416*(x-ww2)/ww;
   fy=3.1416*(y-wh2)/wh;
   fr=map[x+y*ww];

   x1=x-sint(fr*fy);
   y1=y+sint(fr*fx);

   o=4*(x+y*ww); if(x1<0 || x1>=ww || y1<0 || y1>=wh) {dst[o+2]=0; dst[o+1]=0; dst[o]=0; continue;}

// bilinearizer. cute, but heavy
  x0=(int)(x1); y0=(int)(y1); Px=x1-x0; px=1.0-Px; Py=y1-y0; py=1.0-Py;
  o0=x0+y0*ww;
  pp=px*py; pP=px*Py; Pp=Px*py; PP=Px*Py;
 c1.i=isrc[o0];
 c2.i=isrc[o0+1];
 c3.i=isrc[o0+ww];
 c4.i=isrc[o0+1+ww];
 r=c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP;
 g=c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP;
 b=c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP;
 dst[2+o]=r;dst[1+o]=g;dst[0+o]=b;

}}

}
