#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// map: rotation && zooming, smoother

static float sin_tab[360*100];
//////#############
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
static unsigned char lut1[256];
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(2.0*3.14159265*i/36000.0); i=0; 
 for(i=0;i<255;i++) { lut1[i]=i*15/32; }
}

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int rx=rand()*100.0/RAND_MAX; int ry=rand()*100.0/RAND_MAX;
 int o, o1, x, y, x1, y1, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 int *map=buf3;
 float *mapf=buf3;
 float a=map[ww*wh+3]
*(450.0-fbuf[144])/32.0
*(450.0-fbuf[10])/2.0/wh2, b=3.1416/2.0/wh;
 if(rx==1) map[ww*wh+3]*=-1; //printf("\n%d\n", map[ww*wh+3]);

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform map..");
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   fx=b*(x-ww2);
   fy=b*(y-wh2);
   fr=64*sqrt(fx*fx+fy*fy);

   x1=x-fr*sint(fy);
   y1=y+fr*sint(fx);

   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=o1;
  }
 }
 sint_init();
 printf("..done\n");
}

 unsigned char *dst0, *src0;

 // apply effect (zoom)
 dst0=buf2; src0=src;
 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o=x*dx+y*dy; // o - mem offset, 0 <= o <= (ww*dx+y*dy-1)
   x1=x+(x-ww2)*a;
   y1=y+(y-wh2)*a;

   if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
    dst0[0+o]=lut1[dst0[0+o]]+lut1[src0[0+o1]]; // blue
    dst0[1+o]=lut1[dst0[1+o]]+lut1[src0[1+o1]]; // green
    dst0[2+o]=lut1[dst0[2+o]]+lut1[src0[2+o1]]; // red
//    dst0[0+o]=src0[0+o1]; // blue
//    dst0[1+o]=src0[1+o1]; // green
//    dst0[2+o]=src0[2+o1]; // red
  }
 }

 // apply map transform (rotate)
 dst0=dst; src0=buf2; memset(src0,0,4);
 for(y=0; y<wh; y++) {
  for(x=0; x<ww; x++) { o1=x+y*ww; o=o1*4; // o - mem offset, 0 <= o <= (ww*dx+y*dy-1)
    dst0[0+o]=lut1[dst0[0+o]]+lut1[src0[0+map[o1]]]; // blue
    dst0[1+o]=lut1[dst0[1+o]]+lut1[src0[1+map[o1]]]; // green
    dst0[2+o]=lut1[dst0[2+o]]+lut1[src0[2+map[o1]]]; // red
 }}


}
