// ami sine plasma v2.1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

#define swap(a,b) a ^= b ^= a ^= b;

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[360*100];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
}
float cost(float a) { return sint(a+3.14159265/2.0); }

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 union color *isrc=(union color *)src;
 union color *idst=(union color *)dst;
 int o, o1, x, y, dx=bpp, dy=bpp*ww;
 int ww2=ww/2, wh2=wh/2;
 float *map=(float *)buf3;
 float fx=0.0,fy=0.0,fr;
 float a=0.0; //,bpi=3.1416/2/wh;

 unsigned char r,g,b; 

 float x1,y1;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform cache..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 float fx=0.0,fy=0.0,fr;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   fx=3.1416*(x-ww2)/ww;
   fy=3.1416*(y-wh2)/wh;
   fr=sqrt(fx*fx+fy*fy)*10.0*4.0;

   //if(x1>=0 && x1<ww && y1>=0 && y1<wh) o1=x1*dx+y1*dy; else o1=0;
   map[o]=fr;
  }
 }
 for(x=0;x<36000;x++) sin_tab[x]=sin(2.0*3.14159265*x/36000.0);
 printf("..done\n");
}


union color c1,c2,c3,c4,cc;
int o0,i,x0,y0; float px,py,Px,Py,pp,pP,Pp,PP;
//memset(dst,0,ww*4); memset(dst+ww*(wh-1)*4,0,ww*4);
//for(i=0;i<wh;i++){ memset(dst+(i*ww*4),0,4); memset(dst+(i*ww*4+(ww-1)*4),0,4); }
float f=(300.0-fbuf[9])/30.0;
for(y=0;y<wh-1;y++) {
 for(x=0;x<ww;x+=8) { o=(x+y*ww); fx=1.0*x/ww; fy=1.0*y/wh;
  r=127+127.0*(sint(20.0*y/wh*sint(2.2*x/ww+frame*0.021)+sint(13.0*x/ww+y*0.1+f*0.2)));
  g=127+127.0*(sint(21.0*y/wh*sint(2.0*x/ww+frame*0.02)+sint(14.0*x/ww+y*0.2+f*0.1)));
  b=127+127.0*(sint(22.0*y/wh*sint(2.1*x/ww+frame*0.022)+sint(13.0*x/ww+y*0.11+f*3.01)));
  idst[o].s.r=r; idst[o].s.g=g; idst[o].s.b=b;
  for(i=1;i<8;i++) idst[o+i].i=idst[o].i;
}}

if(0) for(y=1; y<wh-1; y++) {
  for(x=1; x<ww-1; x++) {

//   fx=3.1416*(x-ww2)/ww;
//   fy=3.1416*(y-wh2)/wh;
   fx=3.1416*(x-ww2)/wh;
   fy=3.1416*(y-wh2)/wh;
   fr=map[x+y*ww];
//   fr=sqrt(fx*fx+fy*fy)*10.1;

x1=0.0;y1=0.0;

//x1=-sin_tab[fy];
//y1=+sin_tab[fx];

x1+=-sint(fr*fy);
y1+=+sint(fr*fx);
//x1+=-sin(frame*0.02+fr*fy);
//y1+=+sin(frame*0.02+fr*fx);

x1+=x;
y1+=y;

  o=4*(x+y*ww); if(x1<0 || x1>=ww || y1<0 || y1>=wh) {
//   dst[o]=0; dst[o+1]=0; dst[o+2]=0;
   continue;
  }

// bilinearizer. cute, but heavy

x0=(int)(x1); y0=(int)(y1); Px=x1-x0; px=1.0-Px; Py=y1-y0; py=1.0-Py;
  o0=x0+y0*ww;
pp=px*py; pP=px*Py; Pp=Px*py; PP=Px*Py;
// c1.i=isrc[o0];
// c2.i=isrc[o0+1];
// c3.i=isrc[o0+ww];
// c4.i=isrc[o0+1+ww];
 cc.s.r=(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*99/100;
 cc.s.g=(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*99/100;
 cc.s.b=(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*99/100;

dst[2+o]=cc.s.r;dst[1+o]=cc.s.g;dst[0+o]=cc.s.b;


}}

}
