// convo test - zebra

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[36000];
float sint(float a) { int a1=((int)(a*0.0000176838826))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

int co0[7][7]={ // nova waves
{ 0, 0,-1,-1,-1, 0, 0 },
{ 0,-1, 0, 2, 0,-1, 0 },
{-1, 0, 0, 4, 0, 0,-1 },
{-1, 2, 4,256, 4, 2,-1 },
{-1, 0, 0, 4, 0, 0,-1 },
{ 0,-1, 0, 2, 0,-1, 0 },
{ 0, 0,-1,-1,-1, 0, 0 } };
int co1[7][7]={ // rocket pixels
{ 0, 0, 0, 1, 0, 0, 0 },
{ 2, 0, 0, 2, 0, 0, 0 },
{ 0, 0,-1, 4,-1, 0, 0 },
{ 1, 2, 4,16, 4, 2, 1 },
{ 0, 0,-1, 4,-1, 0, 0 },
{ 0, 0, 0, 2, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 } };

int co2[7][7]={ // mazes (seizure warning)
{ 0, 0, 0, 1, 0, 0, 0 },
{ 0, 0, 0, 0, 0, 0, 0 },
{ 0, 0,-2, 0,-2, 0, 0 },
{ 1, 0, 0, 8, 0, 0, 1 },
{ 0, 0,-2, 0,-2, 0, 0 },
{ 0, 0, 0, 0, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 } };

int co3[7][7]={ // fireflies
{ 0, 0, 0, 1, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 },
{ 0, 0, 0,-1, 0, 0, 0 },
{ 1, 1,-1,16,-1, 1, 1 },
{ 0, 0, 0,-1, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 } };

int co[7][7]={ // 
{ 0, 0, 0, 1, 0, 0, 0 },
{ 0, 0, 0, 2, 0, 0, 0 },
{ 0, 0, 4, 4, 4, 0, 0 },
{ 1, 2, 4, 0, -4, 2, 1 },
{ 0, 0,-4, -4,-4, 0, 0 },
{ 0, 0, 0, 2, 0, 0, 0 },
{ 0, 0, 0, 1, 0, 0, 0 } };

static int co_sum=-7777;

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ int x,y,i,j,r,g,b; unsigned int *idst=(unsigned int *)dst;
 union color c0,*csrc=(union color *)src;

 if(co_sum==-7777) { co_sum=0; for(i=0; i<7; i++) for(j=0; j<7; j++) { co_sum+=(co[j][i]); } 
co_sum++;
}

 for(y=3; y<wh-3; y++) for(x=3; x<ww-3; x++)
 { r=0; g=0; b=0;
  for(i=0; i<7; i++) for(j=0; j<7; j++) if(co[j][i]!=0)
  { c0.i=csrc[x+y*ww+i-3+(j-3)*ww].i;
   r+=co[j][i]*c0.s.r;
   g+=co[j][i]*c0.s.g;
   b+=co[j][i]*c0.s.b;
  }
  r/=co_sum; g/=co_sum; b/=co_sum;
  if(r<0) r=0; if(r>255) r=255;
  if(g<0) g=0; if(g>255) g=255;
  if(b<0) b=0; if(b>255) b=255;
  idst[x+y*ww]=(r<<16)|(g<<8)|(b);
 }
}
