// tv input pixo - arnim's splashy colors

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { sint_inited=1; int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

#include <fcntl.h>              /* low-level i/o */
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/videodev2.h>
#define CLEAR(x) memset (&(x), 0, sizeof (x))
typedef enum {
        IO_METHOD_READ,
        IO_METHOD_MMAP,
        IO_METHOD_USERPTR,
} io_method;
static io_method io = IO_METHOD_MMAP;
static void errno_exit (const char * s)
{ fprintf (stderr, "%s error %d, %s\n", s, errno, strerror (errno)); exit (EXIT_FAILURE); }

int fvid=-1;

int xioctl (int fd, int request, void * arg)
{ int r; do r = ioctl (fd, request, arg); while (-1 == r && EINTR == errno); return r; }

void init_device (int ww, int wh)
{
 struct v4l2_capability cap; struct v4l2_cropcap cropcap; struct v4l2_crop crop;
 struct v4l2_format fmt; unsigned int min;
 if (-1 == xioctl (fvid, VIDIOC_QUERYCAP, &cap)) { if (EINVAL == errno) {
  fprintf (stderr, "is no V4L2 device\n"); exit (EXIT_FAILURE);
 } else { errno_exit ("VIDIOC_QUERYCAP"); } }

 if (!(cap.capabilities & V4L2_CAP_VIDEO_CAPTURE)) {
  fprintf (stderr, "is no video capture device\n"); exit (EXIT_FAILURE); }

 switch (io) {
  case IO_METHOD_READ: if (!(cap.capabilities & V4L2_CAP_READWRITE)) {
   fprintf (stderr, "does not support read i/o\n"); exit (EXIT_FAILURE); } break;
  case IO_METHOD_MMAP: case IO_METHOD_USERPTR:
   if (!(cap.capabilities & V4L2_CAP_STREAMING)) {
    fprintf (stderr, "does not support streaming i/o\n"); exit (EXIT_FAILURE); } break;
 }
 /* Select video input, video standard and tune here. */
 CLEAR (cropcap); cropcap.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
 if (0 == xioctl (fvid, VIDIOC_CROPCAP, &cropcap)) {
  crop.type = V4L2_BUF_TYPE_VIDEO_CAPTURE; crop.c = cropcap.defrect; /* reset to default */
  if (-1 == xioctl (fvid, VIDIOC_S_CROP, &crop)) {
   switch (errno) { case EINVAL: /* Cropping not supported. */ break;
    default: /* Errors ignored. */ break; }
  } } else { /* Errors ignored. */ }

 CLEAR (fmt);
 fmt.type                = V4L2_BUF_TYPE_VIDEO_CAPTURE;
 fmt.fmt.pix.width       = ww;
 fmt.fmt.pix.height      = wh;
// fmt.fmt.pix.pixelformat = V4L2_PIX_FMT_YUYV;
 fmt.fmt.pix.pixelformat = V4L2_PIX_FMT_BGR32;
 fmt.fmt.pix.field       = V4L2_FIELD_INTERLACED;

 if (-1 == xioctl (fvid, VIDIOC_S_FMT, &fmt)) errno_exit ("VIDIOC_S_FMT");

 /* Note VIDIOC_S_FMT may change width and height. */

 /* Buggy driver paranoia. */
 min = fmt.fmt.pix.width * 2;
 if (fmt.fmt.pix.bytesperline < min) fmt.fmt.pix.bytesperline = min;
 min = fmt.fmt.pix.bytesperline * fmt.fmt.pix.height;
 if (fmt.fmt.pix.sizeimage < min) fmt.fmt.pix.sizeimage = min;

}

static float f0=0;
static int oww, owh, buf2_inited=0; FILE *f;
void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{ unsigned int *isrc=(unsigned int *)src,
 *idst=(unsigned int *)dst,
 *ibuf2=(unsigned int *)buf2;
 int o,o0,y,x,i;

 if(fvid>0 && (oww!=ww || owh!=wh)) { close(fvid); fvid=-1; buf2_inited=0; }
 if(fvid<=0) { oww=ww;owh=wh; fvid = open("/dev/video0", O_RDWR|O_NONBLOCK, 0);
  if(fvid>0) init_device(ww,wh); }
 sint_init();

 if(mbuf[4]&0x400) { char cnvcmd[1024]; cnvcmd[0]=0;
//  char *pics_dir="/1/_fun/pics";
  char *pics_dir="/mnt/sdc/_web_komix_fun";
  strcat(cnvcmd,"(l=$( find ");
  strcat(cnvcmd,pics_dir);
  strcat(cnvcmd," -iname \"*.jpg\" -o -iname \"*.png\"|wc -l );");
  strcat(cnvcmd,"r=$[ $l * ( $RANDOM + $RANDOM + $RANDOM + $RANDOM ) / 131072 ];");
  strcat(cnvcmd,"f=$( find ");
  strcat(cnvcmd,pics_dir);
  strcat(cnvcmd," -iname \"*.jpg\" -o -iname \"*.png\"|head -n $r|tail -n 1 );");
  strcat(cnvcmd,"cp \"$f\" ./osc-pix.jpg; echo \"[new file: $f]\";");
  strcat(cnvcmd,"touch osc-pix.jpg.ready;) &");
  system(cnvcmd);
  buf2_inited=1;
 }

 if(buf2_inited<2 || owh!=wh || oww!=ww) { f=fopen("osc-pix.jpg.ready","r");
 if(f>0 || (buf2_inited==0 && frame>0)) { if(f>0) fclose(f);
  buf2_inited++; printf("[loading osc-pix.gray .. ");
  char cnvcmd[1024]; sprintf(cnvcmd,"convert -resize %d osc-pix.jpg osc-pix.gray", ww);
  system(cnvcmd); f=fopen("osc-pix.gray","r"); i=fread(buf3,ww,wh,f); fclose(f);
  for(y=0;y<wh;y++) for(x=0;x<ww;x++) memset(buf2+x*4+y*ww*4, buf3[x+y*ww],4);
  printf("got %d pixels]\n",i*ww);
  unlink("osc-pix.jpg.ready");
 }}

// read(fvid,dst,ww*wh*bpp);

/* int o,oo,y,x,i,d1,d2; read(fvid,buf2,ww*wh*bpp);
 for(y=0;y<wh;y++) for(x=0;x<ww;x++) {
  o=(y*ww+x)*4;
  d1=(buf2[o+4+2]+buf2[o+4+1]+buf2[o+4+0]-buf2[o+2]-buf2[o+1]-buf2[o+0])/3;
  d2=(buf2[o+ww*4+2]+buf2[o+ww*4+1]+buf2[o+ww*4+0]-buf2[o+2]-buf2[o+1]-buf2[o+0])/3;
//printf("[%d %d] ", d1,d2);
  oo=o+d1*4+d2*ww*4;
  if(oo<0 || oo>ww*wh*bpp) oo=0;
  for(i=2;i>=0;i--) dst[o+i]=src[oo+i]*254/256;//+buf2[o+i]*2/256;
 }*/
if(0) printf("[%0.2f %0.2f %0.2f %0.2f  %0.2f %0.2f %0.2f %0.2f  ] \n",
fbuf[8],
fbuf[9],
fbuf[10],
fbuf[11],
fbuf[12],
fbuf[13],
fbuf[14],
fbuf[15]
);

union color c1,c2,c3,c4,cc;
int o4,x0,y0; float x1,y1,d1,d2,px,py,Px,Py,pp,pP,Pp,PP;
//unsigned char r,g,b;
// read(fvid,buf2,ww*wh*bpp);
float fframe=frame*0.1+fbuf[14]*0.05;
float cframe=cost(fframe);
float cframey;
 float fframe2=frame*0.038+fbuf[14]*0.2;
 float cframe2=cost(fframe2);

 for(y=0;y<wh;y++)
 { cframey=sint(fframe+y*0.01);
 for(x=0;x<ww;x++) {
  o=(y*ww+x); o4=o*4;
  d1=(buf2[o4+4]-buf2[o4-1])*0.13333;
  d2=(buf2[o4+ww*4]-buf2[o4-ww*4])*0.3333;
  x1=d1+x-2.0*d2;
  y1=d2+y-2.0*d1+1.5;

//  x1=d1+x+cframe; y1=d2+y+1;
// x1=x+d1+(-cost(y*0.01+frame*0.034)-cost(y*0.01+frame*0.011));
// y1=y+d2+(sint(x*0.01+frame*0.038)+sint(x*0.01+frame*0.011));
//  x1=x+4.0*d1*sint(x*0.01)*cost(y*0.01+frame*0.1);
//  y1=y+4.0*d2*cost(y*0.11)*sint(x*0.01+frame*0.1);
// x1=x+d1*0.05*fbuf[144]-cost(y*0.01+frame*0.011)-cost(y*0.01+frame*0.031);
// y1=y+d2*0.1*fbuf[14]+sint(x*0.01+frame*0.03)+sint(x*0.01+frame*0.011);

if(0) {
 o0=(int)x1+(int)y1*ww;
 dst[2+o4]=src[o0*4+2]*96/100;dst[1+o4]=src[o0*4+1]*96/100;dst[0+o4]=src[o0*4+0]*96/100;
// idst[o]=isrc[o0];
} else {
 // bilinearizer. cute, but heavy
 x0=(int)(x1); y0=(int)(y1); Px=x1-x0; px=1.0-Px; Py=y1-y0; py=1.0-Py;
// if(x0<1 || x0>=ww || y0<1 || y0>=wh) { continue; } else  o0=x0+y0*ww; // proper
 if(x0<1 || x0>=ww || y0<1 || y0>=wh) { idst[o]=0; continue; } else  o0=x0+y0*ww; // proper
// o0=x0+y0*ww; if(o0<0 || o0>ww*wh*bpp) o0=0; // faster
 pp=px*py; pP=px*Py; Pp=Px*py; PP=Px*Py;
 c1.i=isrc[o0];
 c2.i=isrc[o0+1];
 c3.i=isrc[o0+ww];
 c4.i=isrc[o0+1+ww];
// cc.s.b=(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*240/256;
// cc.s.g=(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*240/256;
// cc.s.r=(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*240/256;

// Arnim ripply colors
if(0) {
 cc.s.b=(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*98/100 -
  (cframe/7)*(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*30/100;
 cc.s.g=(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*98/100 -
  (cframe/8)*(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*30/100;
 cc.s.r=(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*98/100 -
  (cframe/9)*(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*30/100;
}
 cc.s.b=(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*97/100 -
  (cframe/5.8)*(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*30/100;
 cc.s.g=(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*97/100 -
  (cframe/6.2)*(c1.s.b*pp+c2.s.b*Pp+c3.s.b*pP+c4.s.b*PP)*30/100;
 cc.s.r=(c1.s.r*pp+c2.s.r*Pp+c3.s.r*pP+c4.s.r*PP)*97/100 -
  (cframe/9.1)*(c1.s.g*pp+c2.s.g*Pp+c3.s.g*pP+c4.s.g*PP)*30/100;


 dst[o4+2]=cc.s.r; dst[o4+1]=cc.s.g; dst[o4+0]=cc.s.b;
// idst[o]=cc.i;
// idst[o]=(cc.s.r << 16)|(cc.s.g << 8)|(cc.s.b);
}

 }}

}
