const char get_title[128]	= "swarm (blended & colormapped)";
const char get_version[16]	= "0.2";
const char get_author[32]	= "KotCzarny, Jeff Butterworth";
const char get_description[1]	= "";

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static int map_inited=0, xmax=0, ymax=0;

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

//static int cmap_len, cmap_max; 
#define cmap_len 256*6
//static 
union color cmap[cmap_len];
void cmap_init() { int i; for(i=0;i<=255;i++) {
 cmap[i].s.r=i;         cmap[i].s.g=0;         cmap[i].s.b=0;
 cmap[i+256].s.r=255;   cmap[i+256].s.g=i;     cmap[i+256].s.b=0;
 cmap[i+256*2].s.r=255; cmap[i+256*2].s.g=255; cmap[i+256*2].s.b=i;
 cmap[i+256*3].s.r=255-i; cmap[i+256*3].s.g=255;   cmap[i+256*3].s.b=255;
 cmap[i+256*4].s.r=0; cmap[i+256*4].s.g=255-i; cmap[i+256*4].s.b=255;
 cmap[i+256*5].s.r=0; cmap[i+256*5].s.g=0;   cmap[i+256*5].s.b=255-i;
//printf("[%d,%08x]",i,cmap[i].i);
}}


//#define RAND(v) ((random() % v) - (v/2)) /* random number around 0 */
#define RAND(v) ((random() % (v*32))/32.0 - (v/2)) /* random number around 0 */
#define BEES    30000      /* number of bees */
#define TIMES   3       /* number of time positions recorded */
#define BEEACC  3       /* acceleration of bees */
#define WASPACC 5       /* maximum acceleration of wasp */
#define BEEVEL  10      /* maximum bee velocity */
#define WASPVEL 11      /* maximum wasp velocity */
#define BORDER  50      /* wasp won't go closer than this to the edges */
#define X(t,b)  (bx[t + TIMES*b])         /* addressing into array */
#define Y(t,b)  (by[t + TIMES*b])         /* addressing into array */
#define TRUE	-1

static int b;              /* bee index */
static float bx[TIMES*BEES], by[TIMES*BEES]; /* bee positions x[time][bee#] */
static float bxv[BEES], byv[BEES];           /* bee velocities xv[bee#] */
static float wx[3], wy[3];   /* wasp positions */
static float wxv, wyv;       /* wasp velocity */
static float dx,dy,distance,bf;
static int pointer;

static union color *csrc,*cdst; static int *B;

void swapi(int *a, int *b) { int t; t=*a; *a=*b; *b=t; }
void putp(int x, int y, int c) { if(x<0 || x>=xmax || y<0 || y>=ymax) return; B[x+y*xmax]+=c; }
void putl(int x0, int y0, int x1, int y1, int c) {
// int X1=x1,Y1=y1,X0=x0,Y0=y0;
// if(x0<0 || x0>=conf.ww || y0<0 || y0>=conf.wh) { return; }
// if(x1<0 || x1>=conf.ww || y1<0 || y1>=conf.wh) { return; }
 int x, steep = abs(y1 - y0) > abs(x1 - x0);
 if(steep) { swapi(&x0, &y0); swapi(&x1, &y1); }  if(x0 > x1) { swapi(&x0, &x1); swapi(&y0, &y1); }
 int deltax = x1 - x0, deltay = abs(y1 - y0); int error = deltax / 2; int ystep, y = y0;
 if(y0 < y1) ystep = 1; else ystep = -1;
 for(x=x0; x<x1; x++)
 { if(steep) putp(y,x,c); else putp(x,y,c);
  error = error - deltay; if(error < 0) { y = y + ystep; error = error + deltax; }
 }
// if(conf.lines==3) putp(where,0,Y0,X0,conf.cw);
// if(conf.lines==2) putp(where,0,Y1,X1,conf.cw);
}

void draw(float *x, float *y, int c) { putl((int)x[0],(int)y[0],(int)x[1],(int)y[1],c); }
void draw_bee(int bee) { draw(bx+TIMES*bee, by+TIMES*bee, 1); }
void draw_wasp() { draw(wx, wy, 256); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
//printf("[%f]", RAND(BEEVEL));
 if((mbuf[4]&0x400) != (mbuf[4+8]&0x400))
 { pointer=!pointer; // rmb
// printf("[rmb toggle (%d)]\n",pointer);
 }

if(ww!=xmax || wh!=ymax || map_inited<2) { map_inited++; // FILE *f1; char conv[2048];
// srand((int)time(NULL));
 csrc=(union color *)src; cdst=(union color *)dst; xmax=ww; ymax=wh; B=(int *)buf2;
 sint_init(); cmap_init();

    /* Initialize point positions, velocities, etc. */

    /* wasp */
    if (pointer) { wx[0]=mbuf[0]; wy[0]=mbuf[1]; } else
    {
        wx[0] = BORDER + random() % (ww - 2*BORDER);
        wy[0] = BORDER + random() % (wh - 2*BORDER);
    } wx[1] = wx[0]; wy[1] = wy[0]; wxv = 0; wyv = 0;

    /* bees */
    for (b = 0 ; b < BEES ; b++)
    {
        X(0,b) = random() % ww; X(1,b) = X(0,b);
        Y(0,b) = random() % wh; Y(1,b) = Y(0,b);
        bxv[b] = RAND(BEEVEL); byv[b] = RAND(BEEVEL);
    }

    /* This checks to see if we've gone behind a window. */
    //if (stay_in_front) { BehindWindow = (child != 0); }
}


 // fade bees
 int o,F=32;
 for(o=0; o<ww*wh; o++){
//  B[o]+=(csrc[o].s.r+csrc[o].s.g+csrc[o].s.b)/4/F;
  if(B[o]>F) B[o]-=F; else B[o]=0;
 }


    // Animate()
    // Move the swarm around.
    {
        /* <=- Wasp -=> */
        /* Age the position arrays. */
        wx[2] = wx[1]; wx[1] = wx[0]; wy[2] = wy[1]; wy[1] = wy[0];

        if (pointer) { wx[0]=mbuf[0]; wy[0]=mbuf[1]; } else
        {
            /* Accelerate */
            wxv += RAND(WASPACC); wyv += RAND(WASPACC);

            /* Speed Limit Checks */
            if (wxv > WASPVEL) wxv = WASPVEL; if (wxv < -WASPVEL) wxv = -WASPVEL;
            if (wyv > WASPVEL) wyv = WASPVEL; if (wyv < -WASPVEL) wyv = -WASPVEL;

            /* Move */
            wx[0] = wx[1] + wxv; wy[0] = wy[1] + wyv;

            //Bounce_Against_Windows(wx, wy, &wxv, &wyv, BehindWindow);

            /* Bounce Checks */
            if ((wx[0] < BORDER) || (wx[0] > ww-BORDER-1)) { wxv = -wxv; wx[0] += wxv*2; }
            if ((wy[0] < BORDER) || (wy[0] > wh-BORDER-1)) { wyv = -wyv; wy[0] += wyv*2; }
        }

        /* Don't let things settle down. */
//for(b=0; b<BEES; b+=BEES/10) {
        bxv[random() % BEES] += RAND(BEEVEL*10); byv[random() % BEES] += RAND(BEEVEL*10);
//}

        /* <=- Bees -=> */
        for (b = 0 ; b < BEES ; b++)
        { bf=2.1/BEES*b;
//bxv[b]+=abuf[(b*2+0)%alen]/1600;
//byv[b]+=abuf[(b*2+1)%alen]/1600;
bxv[b]+=600.0/abuf[(b*2+0)%alen];
byv[b]+=600.0/abuf[(b*2+1)%alen];

            /* Age the arrays. */
            X(2,b) = X(1,b); X(1,b) = X(0,b); Y(2,b) = Y(1,b); Y(1,b) = Y(0,b);

            /* Accelerate */
            dx = wx[1] - X(1,b); dy = wy[1] - Y(1,b);
            distance = abs(dx)+abs(dy); /* approximation */
//distance = sqrt(dx*dx+dy*dy);
            if (distance == 0) distance = 1;
            bxv[b] += (dx*BEEACC)*bf/distance;
            byv[b] += (dy*BEEACC)*bf/distance;

            /* Speed Limit Checks */
            if (bxv[b] > BEEVEL) bxv[b] = BEEVEL; if (bxv[b] < -BEEVEL) bxv[b] = -BEEVEL;
            if (byv[b] > BEEVEL) byv[b] = BEEVEL; if (byv[b] < -BEEVEL) byv[b] = -BEEVEL;

            /* Move */
            X(0,b) = X(1,b) + bxv[b]; Y(0,b) = Y(1,b) + byv[b];

draw_bee(b);
        }

//draw_wasp();
            /* Make sure the wasp is within the window. */
            if (wx[0] < BORDER) wx[0] = BORDER; if (wx[0] > ww-BORDER-1) wx[0] = ww-BORDER-1;
            if (wy[0] < BORDER) wy[0] = BORDER; if (wy[0] > wh-BORDER-1) wy[0] = wh-BORDER-1;
 }

 // cmap based paint
 for(o=0; o<ww*wh; o++) { cdst[o].i=cmap[B[o]%((int)cmap_len)].i; }

}
