const char get_title[128]	= "fft bars (vertical)";
const char get_version[16]	= "0.1";
const char get_author[32]	= "KotCzarny";
const char get_description[1]	= "";

#define MAX(a,b) (a>b?a:b)
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static int map_inited=0, xmax=0, ymax=0;

int sint_inited=0; static float sin_tab[36000];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { if(sint_inited) return; sint_inited=1;
 int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

//static int cmap_len, cmap_max; 
#define cmap_len 256*6
//static 
union color cmap[cmap_len];
void cmap_init() { int i; for(i=0;i<=255;i++) {
 cmap[i].s.r=i;         cmap[i].s.g=0;         cmap[i].s.b=0;
 cmap[i+256].s.r=255;   cmap[i+256].s.g=i;     cmap[i+256].s.b=0;
 cmap[i+256*2].s.r=255; cmap[i+256*2].s.g=255; cmap[i+256*2].s.b=i;
 cmap[i+256*3].s.r=255-i; cmap[i+256*3].s.g=255;   cmap[i+256*3].s.b=255;
 cmap[i+256*4].s.r=0; cmap[i+256*4].s.g=255-i; cmap[i+256*4].s.b=255;
 cmap[i+256*5].s.r=0; cmap[i+256*5].s.g=0;   cmap[i+256*5].s.b=255-i;
//printf("[%d,%08x]",i,cmap[i].i);
}}


static union color *csrc,*cdst; static int *B;

void swapi(int *a, int *b) { int t; t=*a; *a=*b; *b=t; }
void putp(int x, int y, int c) { if(x<0 || x>=xmax || y<0 || y>=ymax) return; B[x+y*xmax]+=c; }
void putl(int x0, int y0, int x1, int y1, int c) {
// int X1=x1,Y1=y1,X0=x0,Y0=y0;
// if(x0<0 || x0>=conf.ww || y0<0 || y0>=conf.wh) { return; }
// if(x1<0 || x1>=conf.ww || y1<0 || y1>=conf.wh) { return; }
 int x, steep = abs(y1 - y0) > abs(x1 - x0);
 if(steep) { swapi(&x0, &y0); swapi(&x1, &y1); }  if(x0 > x1) { swapi(&x0, &x1); swapi(&y0, &y1); }
 int deltax = x1 - x0, deltay = abs(y1 - y0); int error = deltax / 2; int ystep, y = y0;
 if(y0 < y1) ystep = 1; else ystep = -1;
 for(x=x0; x<x1; x++)
 { if(steep) putp(y,x,c); else putp(x,y,c);
  error = error - deltay; if(error < 0) { y = y + ystep; error = error + deltax; }
 }
// if(conf.lines==3) putp(where,0,Y0,X0,conf.cw);
// if(conf.lines==2) putp(where,0,Y1,X1,conf.cw);
}

void draw(float *x, float *y, int c) { putl((int)x[0],(int)y[0],(int)x[1],(int)y[1],c); }
void draw_bee(int bee) { draw(bx+TIMES*bee, by+TIMES*bee, 1); }
void draw_wasp() { draw(wx, wy, 256); }


void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{

if(ww!=xmax || wh!=ymax || map_inited<2) { map_inited++; // FILE *f1; char conv[2048];
// srand((int)time(NULL));
 csrc=(union color *)src; cdst=(union color *)dst; xmax=ww; ymax=wh; B=(int *)buf2;
 sint_init(); cmap_init();
}

 int o,F=160;
 for(o=0; o<ww*wh; o++){
//  B[o]=(csrc[o].s.r+csrc[o].s.g+csrc[o].s.b)/4/F;
  if(B[o]>F) B[o]-=F; else B[o]=0;
 }

 int i,x,y,s=4;
 for(x=0; x<ww; x+=s)
 {
  for(i=0;i<s-1;i++) 
  {
   y=fbuf[x/s]*8;
   putl(x+i,0,x+i,wh,y);
  }
 }

 // cmap based paint
 for(o=0; o<ww*wh; o++) { cdst[o].i=cmap[B[o]%((int)cmap_len)].i; }



}
