// [o] shade bobs

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static unsigned int L1[256];
static float sin_tab[360*100];
float sint(float a) { int a1=((int)(a/3.14159265/2.0*36000.0))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }

void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 union color *idst=(union color *)dst; // unsigned int *isrc=(unsigned int *)src;
 int o, x, y;
 int ww2=ww/2, wh2=wh/2;
 int *map=(int *)buf3;

 if(map[ww*wh]!=0x1234 || map[ww*wh+1]!=ww || map[ww*wh+2]!=wh) // diff. map
{ printf("\npix: generating transform cache..");
 if(mbuf[4]==0) {mbuf[0]=ww2; mbuf[1]=wh2;}
 map[ww*wh]=0x1234; map[ww*wh+1]=ww; map[ww*wh+2]=wh; map[ww*wh+3]=1;
 for(y=0; y<wh; y++) { //printf("%d ",y);
  for(x=0; x<ww; x++) { o=x+y*ww; // o - mem offset, 0 <= o <= (ww*wh-1)
   map[o]=sqrt(x*x+y*y);
  }
 }
 for(x=0;x<36000;x++) sin_tab[x]=sin(2.0*3.14159265*x/36000.0);
 for(x=0;x<256;x++) L1[x]=x*63/64;
 printf("..done\n");
}

 // draw bobs
 int x0,y0,s=30,sr,s2=s/2;
 for(y=-s; y<=s; y++) { for(x=-s; x<=s; x++) {
  x0=sint(frame*0.13)*ww2+ww2+x;
  y0=sint(frame*0.24)*wh2+wh2+y;
  if(x0>=0&&x0<ww&&y0>=0&&y0<wh) {
   o=x0+y0*ww; sr=map[(abs(x)+abs(y)*ww)];
//   if(fr<s) isrc[o].s.r+=(char)((s-fr)*0.5);
   if(sr<=s) idst[o].s.r+=s2-sr/2;
  }

  x0=sint(frame*0.03)*ww2+ww2+x;
  y0=sint(frame*0.14)*wh2+wh2+y;
  if(x0>=0&&x0<ww&&y0>=0&&y0<wh) {
   o=x0+y0*ww; sr=map[(abs(x)+abs(y)*ww)];
   if(sr<=s) idst[o].s.g+=s2-sr/2;
  }

  x0=sint(frame*0.33)*ww2+ww2+x;
  y0=sint(frame*0.26)*wh2+wh2+y;
  if(x0>=0&&x0<ww&&y0>=0&&y0<wh) {
   o=x0+y0*ww; sr=map[(abs(x)+abs(y)*ww)];
   if(sr<=s) idst[o].s.b+=s2-sr/2;
  }
 }}

 // fade
 if(0) for(o=0;o<ww*wh*4;o+=4)
 {
    dst[2+o]=L1[src[2+o]]; // red
    dst[1+o]=L1[src[1+o]]; // green
    dst[0+o]=L1[src[0+o]]; // blue
 }

}
