// tv input pixo - plain

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h> //memset

struct color_s { unsigned char b; unsigned char g; unsigned char r; unsigned char a; };
union color { unsigned int i; struct color_s s; };

static float sin_tab[36000];
float sint(float a) { int a1=((int)(a*0.0000176838826))%36000;
 if(a1>=0) return sin_tab[a1]; else return -sin_tab[-a1];
} float cost(float a) { return sint(a+3.14159265/2.0); }
void sint_init() { int i; for(i=0;i<36000;i++) sin_tab[i]=sin(i*0.000174532925); }

#include <fcntl.h>              /* low-level i/o */
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/videodev2.h>
#define CLEAR(x) memset (&(x), 0, sizeof (x))
typedef enum {
        IO_METHOD_READ,
        IO_METHOD_MMAP,
        IO_METHOD_USERPTR,
} io_method;
static io_method io = IO_METHOD_MMAP;
static void errno_exit (const char * s)
{ fprintf (stderr, "%s error %d, %s\n", s, errno, strerror (errno)); exit (EXIT_FAILURE); }

static int fvid=-1;

int xioctl (int fd, int request, void * arg)
{ int r; do r = ioctl (fd, request, arg); while (-1 == r && EINTR == errno); return r; }

void init_device (int ww, int wh)
{
 struct v4l2_capability cap; struct v4l2_cropcap cropcap; struct v4l2_crop crop;
 struct v4l2_format fmt; unsigned int min;
 if (-1 == xioctl (fvid, VIDIOC_QUERYCAP, &cap)) { if (EINVAL == errno) {
  fprintf (stderr, "is no V4L2 device\n"); exit (EXIT_FAILURE);
 } else { errno_exit ("VIDIOC_QUERYCAP"); } }

 if (!(cap.capabilities & V4L2_CAP_VIDEO_CAPTURE)) {
  fprintf (stderr, "is no video capture device\n"); exit (EXIT_FAILURE); }

 switch (io) {
  case IO_METHOD_READ: if (!(cap.capabilities & V4L2_CAP_READWRITE)) {
   fprintf (stderr, "does not support read i/o\n"); exit (EXIT_FAILURE); } break;
  case IO_METHOD_MMAP: case IO_METHOD_USERPTR:
   if (!(cap.capabilities & V4L2_CAP_STREAMING)) {
    fprintf (stderr, "does not support streaming i/o\n"); exit (EXIT_FAILURE); } break;
 }
 /* Select video input, video standard and tune here. */
 CLEAR (cropcap); cropcap.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
 if (0 == xioctl (fvid, VIDIOC_CROPCAP, &cropcap)) {
  crop.type = V4L2_BUF_TYPE_VIDEO_CAPTURE; crop.c = cropcap.defrect; /* reset to default */
  if (-1 == xioctl (fvid, VIDIOC_S_CROP, &crop)) {
   switch (errno) { case EINVAL: /* Cropping not supported. */ break;
    default: /* Errors ignored. */ break; }
  } } else { /* Errors ignored. */ }

 CLEAR (fmt);
 fmt.type                = V4L2_BUF_TYPE_VIDEO_CAPTURE;
 fmt.fmt.pix.width       = ww;
 fmt.fmt.pix.height      = wh;
// fmt.fmt.pix.pixelformat = V4L2_PIX_FMT_YUYV;
 fmt.fmt.pix.pixelformat = V4L2_PIX_FMT_BGR32;
 fmt.fmt.pix.field       = V4L2_FIELD_INTERLACED;

 if (-1 == xioctl (fvid, VIDIOC_S_FMT, &fmt)) errno_exit ("VIDIOC_S_FMT");

 /* Note VIDIOC_S_FMT may change width and height. */

 /* Buggy driver paranoia. */
 min = fmt.fmt.pix.width * 2;
 if (fmt.fmt.pix.bytesperline < min) fmt.fmt.pix.bytesperline = min;
 min = fmt.fmt.pix.bytesperline * fmt.fmt.pix.height;
 if (fmt.fmt.pix.sizeimage < min) fmt.fmt.pix.sizeimage = min;

}

static int oww, owh;
void pix(int frame, int alen, int achannels, short *abuf, double *fbuf,
 int ww, int wh, int bpp, int *mbuf, unsigned char *dst, unsigned char *src,
 unsigned char *buf2, unsigned char *buf3)
{
 if(fvid>0 && (oww!=ww || owh!=wh)) { close(fvid); fvid=-1; }
 if(fvid<=0) { oww=ww;owh=wh; fvid = open("/dev/video0", O_RDWR|O_NONBLOCK, 0);
  if(fvid>0) init_device(ww,wh); }

 read(fvid,dst,ww*wh*bpp);
/*
 int o,y,x,i;
 read(fvid,buf2,ww*wh*bpp);
 for(y=0;y<wh;y++) for(x=0;x<ww;x++) { o=(y*ww+x)*4;
//  for(i=2;i>=0;i--) dst[o+i]=(src[o+i]/buf2[o+i]);
 }
*/

}
